static char rcsid[] = "@(#)$Id: info.c,v 1.6 2006/03/31 17:43:20 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.6 $   $State: Exp $
 *
 *  Author: Kari Hurtta <hurtta+elm@posti.FMI.FI>
 *      or  Kari Hurtta <elm@elmme-mailer.org>
 *****************************************************************************/

#include "def_list.h"
#include "s_me.h"
#include "mailerlib.h"


DEBUG_VAR(Debug,__FILE__,"mail");

struct menu_anon_param {
    struct list_info *list_info;
};


enum { list_info_mp_param,
       list_info_mp_COUNT };


#if ANSI_C
#define S_(x) static x;
#else
#define S_(x)
#endif


S_(subpage_simple_redraw sb_update_list_info_title)
static int sb_update_list_info_title(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{
    menu_ClearScreen(ptr);

    menu_print_format_center(ptr,0,
			     CATGETS(elm_msg_cat, MeSet, MeListInfoTitle,
				     "List info"));

    return 1;   /* title completed */
}

S_(subpage_simple_redraw sb_update_list_info_menu)
static int sb_update_list_info_menu(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{
    menu_ClearScreen(ptr);

    menu_print_format_center(ptr,0,
			     CATGETS(elm_msg_cat, MeSet, 
				     MeListInfoMenu1,
				     "Mail to l)ist, list o)wner, or go to i)index"));

    menu_print_format_center(ptr,1,
			     CATGETS(elm_msg_cat, MeSet, 
				     MeListInfoMenu2,
				     "List h)elp, list a)rchive, s)ubscribe or u)nsubscribe list"));


    return 1;   /* title completed */
}

S_(subpage_simple_redraw sb_update_list_info_part)
static int sb_update_list_info_part(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{

    struct menu_anon_param *A = mp_lookup_anon(list,list_info_mp_param);
    int line = 0;

    int LINES, COLUMNS;

    menu_get_sizes(ptr, &LINES, &COLUMNS);

    menu_ClearScreen(ptr);


    if (A->list_info->list_phrase) {
	menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListName,
					 "List name       : %S"),
		      A->list_info->list_phrase);
	line++;
    }
    if (A->list_info->list_id) {
	menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListID,
					 "List ID         : %s"),
		      A->list_info->list_id);
	line++;
    }

    if (A->list_info->list_post_no) {

	if (line) 
	    line++;

	if (A->list_info->list_post_no_comment) {
	    menu_print_format_center(ptr,line,CATGETS(elm_msg_cat, MeSet, 
					     MeListInfoListNoPostX,
					     "Mailing list do not accept postings (%S)"),
			  A->list_info->list_post_no_comment);
	} else {
	    menu_print_format_center(ptr,line,CATGETS(elm_msg_cat, MeSet, 
						      MeListInfoListNoPost,
						      "Mailing list do not accept postings."));
	}
	line ++;

    }

    if (line) 
	line++;

    if (A->list_info->list_post_len > 0) {
	int i;
	
	for ( i = 0; i < A->list_info->list_post_len; i++) {
	    struct string * X = raw_from_url (A->list_info->list_post[i].url);

	    if (!X)
		X = format_string(FRM("?ERROR?"));

	    if (0 == i) {
		if (A->list_info->list_post[i].comment)
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListPost,
						     "List post       : <%S> (%S)"),
				  X,A->list_info->list_post[i].comment);
		else
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListPost0,
						     "List post       : <%S>"),
				  X);
	    } else {
		if (A->list_info->list_post[i].comment)
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S> (%S)"),
				  X,A->list_info->list_post[i].comment);
		else
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S>"),
				  X);
	    }
	    
	    free_string(&X);
	    line++;
	}
    }


    if (A->list_info->list_owner_len > 0) {
	int i;
	
	for ( i = 0; i < A->list_info->list_owner_len; i++) {
	    struct string * X = raw_from_url (A->list_info->list_owner[i].url);

	    if (!X)
		X = format_string(FRM("?ERROR?"));

	    if (0 == i) {
		if (A->list_info->list_owner[i].comment)
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListOwner,
						     "List owner      : <%S> (%S)"),
				  X,A->list_info->list_owner[i].comment);
		else
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListOwner0,
						     "List owner      : <%S>"),
				  X);
	    } else {
		if (A->list_info->list_owner[i].comment)
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S> (%S)"),
				  X,A->list_info->list_owner[i].comment);
		else
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S>"),
				  X);
	    }
	    
	    free_string(&X);
	    line++;
	}
    }

    if (A->list_info->list_subscribe_len > 0) {
	int i;
	
	for ( i = 0; i < A->list_info->list_subscribe_len; i++) {
	    struct string * X = raw_from_url (A->list_info->list_subscribe[i].url);

	    if (!X)
		X = format_string(FRM("?ERROR?"));

	    if (0 == i) {
		if (A->list_info->list_subscribe[i].comment)
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListSubscribe,
						     "List subscribe  : <%S> (%S)"),
				  X,A->list_info->list_subscribe[i].comment);
		else
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListSubscribe0,
						     "List subscribe  : <%S>"),
				  X);
	    } else {
		if (A->list_info->list_subscribe[i].comment)
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S> (%S)"),
				  X,A->list_info->list_subscribe[i].comment);
		else
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S>"),
				  X);
	    }
	    
	    free_string(&X);
	    line++;
	}
    }

    if (A->list_info->list_unsubscribe_len > 0) {
	int i;
	
	for ( i = 0; i < A->list_info->list_unsubscribe_len; i++) {
	    struct string * X = raw_from_url (A->list_info->list_unsubscribe[i].url);

	    if (!X)
		X = format_string(FRM("?ERROR?"));

	    if (0 == i) {
		if (A->list_info->list_unsubscribe[i].comment)
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListUnsubscribe,
						     "List unsubscribe: <%S> (%S)"),
				  X,A->list_info->list_unsubscribe[i].comment);
		else
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListUnsubscribe0,
						     "List unsubscribe: <%S>"),
				  X);
	    } else {
		if (A->list_info->list_unsubscribe[i].comment)
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S> (%S)"),
				  X,A->list_info->list_unsubscribe[i].comment);
		else
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S>"),
				  X);
	    }
	    
	    free_string(&X);
	    line++;
	}
    }

    if (A->list_info->list_help_len > 0) {
	int i;
	
	for ( i = 0; i < A->list_info->list_help_len; i++) {
	    struct string * X = raw_from_url (A->list_info->list_help[i].url);

	    if (!X)
		X = format_string(FRM("?ERROR?"));

	    if (0 == i) {
		if (A->list_info->list_help[i].comment)
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListHelp,
						     "List help       : <%S> (%S)"),
				  X,A->list_info->list_help[i].comment);
		else
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListHelp0,
						     "List help       : <%S>"),
				  X);
	    } else {
		if (A->list_info->list_help[i].comment)
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S> (%S)"),
				  X,A->list_info->list_help[i].comment);
		else
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S>"),
				  X);
	    }
	    
	    free_string(&X);
	    line++;
	}
    }

    if (A->list_info->list_archive_len > 0) {
	int i;
	
	for ( i = 0; i < A->list_info->list_archive_len; i++) {
	    struct string * X = raw_from_url (A->list_info->list_archive[i].url);

	    if (!X)
		X = format_string(FRM("?ERROR?"));

	    if (0 == i) {
		if (A->list_info->list_archive[i].comment)
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListArchive,
						     "List archive    : <%S> (%S)"),
				  X,A->list_info->list_archive[i].comment);
		else
		    menu_PutLineX(ptr,line,0,CATGETS(elm_msg_cat, MeSet, MeListInfoListArchive0,
						     "List archive    : <%S>"),
				  X);
	    } else {
		if (A->list_info->list_archive[i].comment)
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S> (%S)"),
				  X,A->list_info->list_archive[i].comment);
		else
		    menu_PutLineX(ptr,line,0,FRM(    "                : <%S>"),
				  X);
	    }
	    
	    free_string(&X);
	    line++;
	}
    }

    return 1;   /* info completed */
}





static void set_list_info_screen P_((struct menu_context  *page, 
				  struct screen_parts *LOC,
				  struct menu_param  *LIST));
static void set_list_info_screen(page,LOC, LIST)
     struct menu_context  *page;
     struct screen_parts *LOC;
     struct menu_param  *LIST;    
{    
    int   LINES, COLUMNS;	

    menu_get_sizes(page,&LINES, &COLUMNS);

    /* Title part */

    if (! LOC->title_page)
	LOC->title_page = new_menu_subpage(page,0,2,sb_update_list_info_title,
					   LIST);
    else
	menu_subpage_relocate(LOC->title_page,page,0,2);

    /* Info part */

    if (! LOC->header_page)
	LOC->header_page = new_menu_subpage(page,2,LINES-8,
					    sb_update_list_info_part,LIST);
    else
	menu_subpage_relocate(LOC->header_page,page,2,LINES-8);

    /* Menu part */

    if (LOC->menu_page)
	menu_subpage_relocate(LOC->menu_page,page,LINES-6,2);
    else 
	LOC->menu_page = new_menu_subpage(page,LINES-6,2,
					  sb_update_list_info_menu,LIST);
  
    /* Prompt part */

    if (LOC->prompt_page)
	menu_subpage_relocate(LOC->prompt_page,page,LINES-4,4);
    else 
	LOC->prompt_page = new_menu_subpage(page,LINES-4,4,
					    subpage_simple_noredraw,LIST);
}

static void check_list_info_screen P_((struct screen_parts *LOC,
				   struct menu_param *list));
static void check_list_info_screen(LOC,list)
     struct screen_parts *LOC;
     struct menu_param *list;
{
    /* Title area */

    if (menu_resized(LOC->title_page)) {
	DPRINT(Debug,1, (&Debug, "title page resized\n"));

    }
    if (menu_need_redraw(LOC->title_page)) {
	DPRINT(Debug,1, (&Debug, "title page redraw???\n"));
	sb_update_list_info_title(LOC->title_page,list);
    }

    /* Menu area */

    if (menu_resized(LOC->menu_page)) {
	DPRINT(Debug,1, (&Debug, "menu page resized\n"));
	
    }
    if (menu_need_redraw(LOC->menu_page)) {
	DPRINT(Debug,1, (&Debug, "menu page redraw\n"));
	sb_update_list_info_menu(LOC->menu_page,list);
    }

    /* Prompt area */
    if (menu_resized(LOC->prompt_page)) {
	DPRINT(Debug,1, (&Debug, "prompt page resized\n"));
    }
    if (menu_need_redraw(LOC->prompt_page)) {
	DPRINT(Debug,7, (&Debug, "prompt page redraw\n"));
	menu_ClearScreen(LOC->prompt_page);

	show_last_error();	/* for those operations that have to
				 * clear the footer except for a message.
				 */
    }

    if (menu_resized(LOC->header_page)) {
	DPRINT(Debug,1, (&Debug, "header page resized\n"));

	menu_trigger_redraw(LOC->header_page);
    }

    if (menu_need_redraw(LOC->header_page)) {

	DPRINT(Debug,7, (&Debug, "info page redraw\n"));

	sb_update_list_info_part(LOC->header_page,list);
    }
}

/* ------------------------------------------------------------------------- */

static int mail_to_url_mailing P_((struct menu_context  *page,
				   struct menu_context *prompt_area,
				   struct MailboxView *mailbox,
				   const struct url *url,
				   struct AliasView   *aview,
				   int edit, int ask_send));

static int mail_to_url_mailing(page,prompt_area,mailbox,url,aview, 
			       edit,ask_send)
     struct menu_context  *page;
     struct menu_context *prompt_area;
     struct MailboxView *mailbox;
     CONST struct url *url;
     struct AliasView   *aview;
     int edit;
     int ask_send;
{
    struct mailer_info *mailer_info   = get_mailer_info();
    struct mailing_headers headers;
    int r = 0;
    struct text_block *body = NULL;
    int errors = 0;

    zero_mailing_headers(&headers);
    
    if (!mailer_info) {
        DPRINT(Debug,5,(&Debug, 
			"mail_to_url_mailing: No mailer_info\n"));
	return 0;
    }

    body = give_text_body_from_url(url,mime_body_keywords,&errors);
    if (errors)
	goto fail;


    r = set_mailing_headers_from_url(&headers,url,mailer_info);
    if (!r) {
	DPRINT(Debug,5,(&Debug, 
			"mail_to_url_mailing: set_mailing_headers_from_url failed!\n"));
	goto fail;
    }

    r = send_msg_middle2(&headers,0,
			 (edit ? MAIL_EDIT_MSG : 0) |
			 (ask_send ? MAIL_ASK_SEND : 0),
			 NO,mailer_info,mailbox,aview,
			 page,prompt_area,body);
    
    if (!r) {
	DPRINT(Debug,5,(&Debug, 
			"mail_to_url_mailing: send_msg_middle2 failed!\n"));
	goto fail;
    }
    
 fail:
    if (body)
	free_block(&body);

    free_mailing_headers(&headers);
    free_mailer_info(&mailer_info);

    DPRINT(Debug,5,(&Debug, 
		    "mail_to_url_mailing=%d\n",r));
    return r;

}

static int mail_to_url P_((struct menu_context  *page,
			   struct menu_context *prompt_area,
			   struct MailboxView *mailbox,
			   const struct url *url,
			   struct AliasView   *aview,
			   int edit,
			   int ask_send));

static int mail_to_url(page,prompt_area,mailbox,url,aview, edit,ask_send)
     struct menu_context  *page;
     struct menu_context *prompt_area;
     struct MailboxView *mailbox;
     CONST struct url *url;
     struct AliasView   *aview;
     int edit;
     int ask_send;
{
    int r = 0;
    enum url_type T = get_url_type(url);

    struct string *url_text = raw_from_url(url);

    switch (T) {
    case url_unknown:
	if (url_text)
	    lib_error(CATGETS(elm_msg_cat, MeSet, 
			      MeUnknownUrlMail,
			      "Unsupported URL type. Can not mail to %S"),
		      url_text);
	goto failure;


    case url_mailing: 
	
	r = mail_to_url_mailing(page,prompt_area,mailbox,url,aview,edit,
				ask_send);
	break;
    }

 failure:

    if (url_text)
	free_string(& (url_text));

    return r;
}



/* ------------------------------------------------------------------------- */

#if ANSI_C
static subpage_simple_redraw sb_update_title_list_post_selection1;
#endif
static int sb_update_title_list_post_selection1(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{
    menu_ClearScreen(ptr);

    menu_print_format_center(ptr,0,
			     CATGETS(elm_msg_cat, MeSet, 
				     MeListInfoTitleListPost,
				     "List-Post selection for mailing"));

    return 1;   /* title completed */
}


static void mail_to_list P_((struct list_info *list_info,
			     struct MailboxView *mailbox,
			     struct AliasView   *aview,
			     struct menu_context *page,
			     struct menu_context  *prompt_area));
static void mail_to_list(list_info,mailbox,
			  aview,page,prompt_area)
     struct list_info *list_info;
     struct MailboxView *mailbox;
     struct AliasView   *aview;
     struct menu_context  *page;
     struct menu_context  *prompt_area;
{
    CONST struct url * url = NULL;


    if (list_info->list_post_no) {
	lib_error(CATGETS(elm_msg_cat, MeSet,
			  MeGenericReplyNoPosting,		       
			  "Mailing list do not accept postings!"));
	return;
    }

    if (list_info->list_post_len < 1) {
	lib_error(CATGETS(elm_msg_cat, MeSet,
			  MeGenericReplyNoListPost,		       
			  "No information for posting to list."));
	return;
    }

    url = select_post_url(list_info->list_post, list_info->list_post_len,
			  page,sb_update_title_list_post_selection1);
    if (!url)
	return;

    mail_to_url(page,prompt_area,mailbox,url,aview,1,0);
}

#if ANSI_C
static subpage_simple_redraw sb_update_title_list_owner_selection1;
#endif
static int sb_update_title_list_owner_selection1(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{
    menu_ClearScreen(ptr);

    menu_print_format_center(ptr,0,
			     CATGETS(elm_msg_cat, MeSet, 
				     MeListInfoTitleListOwner,
				     "List-Owner selection for mailing"));

    return 1;   /* title completed */
}


static void mail_to_list_owner P_((struct list_info *list_info,
				   struct MailboxView *mailbox,
				   struct AliasView   *aview,
				   struct menu_context *page,
				   struct menu_context  *prompt_area));
static void mail_to_list_owner(list_info,mailbox,
			       aview,page,prompt_area)
     struct list_info *list_info;
     struct MailboxView *mailbox;
     struct AliasView   *aview;
     struct menu_context  *page;
     struct menu_context  *prompt_area;
{
    CONST struct url * url = NULL;

    if (list_info->list_owner_len < 1) {
	lib_error(CATGETS(elm_msg_cat, MeSet,
			  MeGenericReplyNoListOwner,		       
			   "No information for posting to list owner."));
	return;

    }

    url = select_post_url(list_info->list_owner, list_info->list_owner_len,
			  page,sb_update_title_list_owner_selection1);
    if (!url)
	return;

    mail_to_url(page,prompt_area,mailbox,url,aview,1,0);
}


#if ANSI_C
static subpage_simple_redraw sb_update_title_list_help_selection1;
#endif
static int sb_update_title_list_help_selection1(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{
    menu_ClearScreen(ptr);

    menu_print_format_center(ptr,0,
			     CATGETS(elm_msg_cat, MeSet, 
				     MeListInfoTitleListHelp,
				     "List-Help selection"));

    return 1;   /* title completed */
}


static void list_help P_((struct list_info *list_info,
			  struct MailboxView *mailbox,
			  struct AliasView   *aview,
			  struct menu_context *page,
			  struct menu_context  *prompt_area));
static void list_help(list_info,mailbox,
		      aview,page,prompt_area)
     struct list_info *list_info;
     struct MailboxView *mailbox;
     struct AliasView   *aview;
     struct menu_context  *page;
     struct menu_context  *prompt_area;
{
    CONST struct url * url = NULL;

    if (list_info->list_help_len < 1) {
	lib_error(CATGETS(elm_msg_cat, MeSet,
			  MeListInfoNoListHelp,		       
			   "No information for list help."));
	return;

    }

    url = select_post_url(list_info->list_help, list_info->list_help_len,
			  page,sb_update_title_list_help_selection1);
    if (!url)
	return;

    mail_to_url(page,prompt_area,mailbox,url,aview,0,1);
}

#if ANSI_C
static subpage_simple_redraw sb_update_title_list_archive_selection1;
#endif
static int sb_update_title_list_archive_selection1(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{
    menu_ClearScreen(ptr);

    menu_print_format_center(ptr,0,
			     CATGETS(elm_msg_cat, MeSet, 
				     MeListInfoTitleListArchive,
				     "List-Archive selection"));

    return 1;   /* title completed */
}



static void list_archive P_((struct list_info *list_info,
			     struct MailboxView *mailbox,
			     struct AliasView   *aview,
			     struct menu_context *page,
			     struct menu_context  *prompt_area));
static void list_archive(list_info,mailbox,
			 aview,page,prompt_area)
     struct list_info *list_info;
     struct MailboxView *mailbox;
     struct AliasView   *aview;
     struct menu_context  *page;
     struct menu_context  *prompt_area;
{
    CONST struct url * url = NULL;

    if (list_info->list_archive_len < 1) {
	lib_error(CATGETS(elm_msg_cat, MeSet,
			  MeListInfoNoListArchive,		       
			   "No information for list archive."));
	return;

    }

    url = select_post_url(list_info->list_archive, list_info->list_archive_len,
			  page,sb_update_title_list_archive_selection1);
    if (!url)
	return;

    mail_to_url(page,prompt_area,mailbox,url,aview,0,1);
}

#if ANSI_C
static subpage_simple_redraw sb_update_title_list_subscribe_selection1;
#endif
static int sb_update_title_list_subscribe_selection1(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{
    menu_ClearScreen(ptr);

    menu_print_format_center(ptr,0,
			     CATGETS(elm_msg_cat, MeSet, 
				     MeListInfoTitleListSubscribe,
				     "List-Subscribe selection"));

    return 1;   /* title completed */
}


static void list_subscribe P_((struct list_info *list_info,
			       struct MailboxView *mailbox,
			       struct AliasView   *aview,
			       struct menu_context *page,
			       struct menu_context  *prompt_area));
static void list_subscribe(list_info,mailbox,
			   aview,page,prompt_area)
     struct list_info *list_info;
     struct MailboxView *mailbox;
     struct AliasView   *aview;
     struct menu_context  *page;
     struct menu_context  *prompt_area;
{
    CONST struct url * url = NULL;

    if (list_info->list_subscribe_len < 1) {
	lib_error(CATGETS(elm_msg_cat, MeSet,
			  MeListInfoNoListSubscribe,		       
			   "No information for list subscribe."));
	return;

    }

    url = select_post_url(list_info->list_subscribe, 
			  list_info->list_subscribe_len,
			  page,sb_update_title_list_subscribe_selection1);
    if (!url)
	return;

    mail_to_url(page,prompt_area,mailbox,url,aview,0,1);
}

#if ANSI_C
static subpage_simple_redraw sb_update_title_list_unsubscribe_selection1;
#endif
static int sb_update_title_list_unsubscribe_selection1(ptr,list)
     struct menu_context  *ptr;
     struct menu_param *list;
{
    menu_ClearScreen(ptr);

    menu_print_format_center(ptr,0,
			     CATGETS(elm_msg_cat, MeSet, 
				     MeListInfoTitleListUnsubscribe,
				     "List-Unsubscribe selection"));

    return 1;   /* title completed */
}


static void list_unsubscribe P_((struct list_info *list_info,
				 struct MailboxView *mailbox,
				 struct AliasView   *aview,
				 struct menu_context *page,
				 struct menu_context  *prompt_area));
static void list_unsubscribe(list_info,mailbox,
			   aview,page,prompt_area)
     struct list_info *list_info;
     struct MailboxView *mailbox;
     struct AliasView   *aview;
     struct menu_context  *page;
     struct menu_context  *prompt_area;
{
    CONST struct url * url = NULL;

    if (list_info->list_unsubscribe_len < 1) {
	lib_error(CATGETS(elm_msg_cat, MeSet,
			  MeListInfoNoListUnsubscribe,		       
			   "No information for list unsubscribe."));
	return;

    }

    url = select_post_url(list_info->list_unsubscribe, 
			  list_info->list_unsubscribe_len,
			  page,sb_update_title_list_unsubscribe_selection1);
    if (!url)
	return;

    mail_to_url(page,prompt_area,mailbox,url,aview,0,1);
}



/* Returns 'i' if should go index */
int list_info(index,mailbox,aview,parent_page,old_prompt)
     int index;
     struct MailboxView *mailbox;
     struct AliasView   *aview;
     struct menu_context  *parent_page;
     struct menu_context  *old_prompt;
{
    struct header_rec * current_header = give_header(mailbox,index);
    int ch;
    int retch = 0;
    int update = 0;

    int screen_initialized = 0;

    struct menu_anon_param A;
    struct menu_context *page = NULL;
    struct screen_parts  LOC  = { NULL, NULL, NULL, NULL };
    struct menu_param  PARAM[list_info_mp_COUNT+1] = { 
	{ mp_anon_param,0 },
	{ mp_END,0 }
    };

    struct menu_context  *this_page    = NULL;
    struct menu_context  *this_prompt  = NULL;


    if (!current_header) {

	return 0;
    }


    if (! current_header->list_info) {

	lib_error(CATGETS(elm_msg_cat, MeSet,
			  MeGenericReplyNotAList,		       
			  "Mailing list information is not a available."));

	return 0; 
    }

    A.list_info      = current_header->list_info;

    mp_list_set_anon(PARAM,list_info_mp_param,&A);


    /* Make possible type two character commands without printing
       of info screen .. this waits a second for command
    */
    if (old_prompt) {
	int lin,col;
	this_page    = parent_page;
	this_prompt  = old_prompt;

	menu_Write_to_screen(old_prompt,FRM(": "));
	menu_GetXYLocation(old_prompt,&lin,&col);
	menu_CleartoEOS(old_prompt); 
	show_last_error();
	menu_MoveCursor(old_prompt,lin,col);
	
	ch = menu_ReadCh(old_prompt, 
			 REDRAW_MARK|READCH_CURSOR|READCH_resize|
			 READCH_sig_char|READCH_poll);

	if (ch == EOF ||
	    ch == TERMCH_interrupt_char)
	    goto OUT;
	if (ch != TIMEOUT_MARK)
	    goto peek_key;

    }


    for (;;) {

	if (! screen_initialized) {

	    page = new_menu_context();
	    set_list_info_screen(page,&LOC,PARAM);

	    this_page    = page;
	    this_prompt  = LOC.prompt_page;

	    screen_initialized = 1;
	}

	if (menu_resized(page)) {
	    set_list_info_screen(page,&LOC,PARAM);
	    update = 1;
	}

	if (update || menu_need_redraw(page)) {
	    menu_ClearScreen(page);

	    /* Call refresh routines of children */
	    menu_redraw_children(page);
	    	    
	    update = 0;
	    show_last_error(); 
	} 


	check_list_info_screen(&LOC,PARAM);

	{
	    int lin,col;
	    
	    menu_ClearLine(LOC.prompt_page,0);
	    
 	    menu_PutLineX (LOC.prompt_page,0, 0, 
			   CATGETS(elm_msg_cat, MeSet, MeListInfoPrompt,
				   "List info: "));
	    menu_GetXYLocation(LOC.prompt_page,&lin,&col);
	    
	    menu_CleartoEOS(LOC.prompt_page);   
	    
	    show_last_error();
	    menu_MoveCursor(LOC.prompt_page,lin,col);
	    
	    ch = menu_ReadCh(LOC.prompt_page, 
			     REDRAW_MARK|READCH_CURSOR|READCH_resize|
			     READCH_sig_char);
	    
	    menu_CleartoEOS(LOC.prompt_page);
	    set_error("");	/* clear error buffer */
	}

    peek_key:
	switch (ch) {
	case RESIZE_MARK:
	    DPRINT(Debug,4, (&Debug, " ... resizing\n"));
	    
	    continue;
	    
	case ctrl('L'):
	case REDRAW_MARK:
	    update = 1;
	    continue;

	case ctrl('J'):
	case ctrl('M'):
	    goto OUT;


	case 'l':
	    menu_Write_to_screen(this_prompt,
				 CATGETS(elm_msg_cat, MeSet,
					 MeListInfoMailToList,
					 "Mail to list"));
	    FlushBuffer();

	    mail_to_list(current_header->list_info,mailbox,aview,
			 this_page,this_prompt);
	    goto OUT;

	case 'o':
	    menu_Write_to_screen(this_prompt,
				 CATGETS(elm_msg_cat, MeSet,
					 MeListInfoMailToListOwner,
					 "Mail to list owner"));
	    FlushBuffer();

	    mail_to_list_owner(current_header->list_info,mailbox,aview,
			       this_page,this_prompt);
	    goto OUT;

	case 'h':
	    menu_Write_to_screen(this_prompt,
				 CATGETS(elm_msg_cat, MeSet,
					 MeListInfoListHelpP,
					 "List help"));
	    FlushBuffer();

	    list_help(current_header->list_info,mailbox,aview,
		      this_page,this_prompt);
	    goto OUT;

	case 'a':
	    menu_Write_to_screen(this_prompt,
				 CATGETS(elm_msg_cat, MeSet,
					 MeListInfoListArchiveP,
					 "List archive"));
	    FlushBuffer();

	    list_archive(current_header->list_info,mailbox,aview,
			 this_page,this_prompt);
	    goto OUT;

	case 's':
	    menu_Write_to_screen(this_prompt,
				 CATGETS(elm_msg_cat, MeSet,
					 MeListInfoListSubscribeP,
					 "List subscribe"));
	    FlushBuffer();

	    list_subscribe(current_header->list_info,mailbox,aview,
			   this_page,this_prompt);
	    goto OUT;

	case 'u':
	    menu_Write_to_screen(this_prompt,
				 CATGETS(elm_msg_cat, MeSet,
					 MeListInfoListUnsubscribeP,
					 "List unsubscribe"));
	    FlushBuffer();

	    list_unsubscribe(current_header->list_info,mailbox,aview,
			     this_page,this_prompt);
	    goto OUT;

	case 'i':
	    menu_Write_to_screen(this_prompt,
				 CATGETS(elm_msg_cat, MeSet,
					 MeGenericReplyIndex,
					 "Go to index"));
	    retch = 'i';
	    FlushBuffer();
	    /* FALLTHRU */
	case 'q':
	case 'x':
	case TERMCH_interrupt_char:
	    goto OUT;

	case EOF:
	    retch = EOF;
	    goto OUT;

	default:
	    lib_error(CATGETS(elm_msg_cat, MeSet,
			      MeGenericReplyUnknownCommand,		       
			      "Unknown command: %c"), 
		      ch);
	    continue;
	}    
    }

 OUT:

    error_wait();

    if (screen_initialized) {
	free_mailbox_screen(&LOC);
	
	erase_menu_context(&page);
	
	menu_trigger_redraw(parent_page);
    } else if (old_prompt)
	menu_trigger_redraw(old_prompt);

    return retch;	
}



/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */


